// SPDX-License-Identifier: LGPL-3.0-or-later
// See Notices.txt for copyright information
use fayalite::prelude::*;

#[hdl(outline_generated)]
pub struct S<T, Len: Size, T2> {
    pub a: T,
    b: UInt<3>,
    pub(crate) c: ArrayType<UInt<1>, Len>,
    pub d: T2,
}

#[hdl(outline_generated)]
pub struct S3<const LEN: usize, T> {
    pub a: T,
    b: UInt<3>,
    pub(crate) c: Array<UInt<1>, LEN>,
    pub d: S<T, ConstUsize<LEN>, ()>,
}

#[hdl(outline_generated)]
pub enum E<T> {
    A,
    B(UInt<3>),
    C(T),
}

#[hdl(outline_generated)]
pub struct S2<T = ()> {
    pub v: E<T>,
}
